#!/usr/bin/python

#
# Copyright (C) 2008 by OpenMoko, Inc.
# Written by Willie Chen <willie_chen@openmoko.com>
#            Marek Lindner <marek@openmoko.com>
# All Rights Reserved
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#

import os


def debug(msg):
	print msg

### delayed init sequence for the gsm modem ###
def _power_on_first(self):
	os.system("echo 0 > " + self.pows)
	self.timer_add(1, _power_on_sec, self)

def _power_on_sec(self):
	os.system("echo 1 > " + self.pows)
	self.timer_add(1, _power_on_third, self)

def _power_on_third(self):
	os.system("echo 1 > " + self.res)
	self.timer_add(1, _power_on_fourth, self)

def _power_on_fourth(self):
	os.system("echo 0 > " + self.res)
	self.timer_add(2, _power_on_fifth, self)

def _power_on_fifth(self):
	self.timer_running = 0
	if (self.timer_mode == 0):
		self.power_off

class gsm:
	def __init__(self, name="GSM"):
		self.name = name
		self.enabled = 0
		self.enable_str = "off"
		self.timer_running = 0
		self.timer_mode = 0
		self.pows = "/sys/bus/platform/devices/neo1973-pm-gsm.0/power_on"
		self.res = "/sys/bus/platform/devices/neo1973-pm-gsm.0/reset"
		self.dl = "/sys/bus/platform/devices/neo1973-pm-gsm.0/download"
		#debug("enter init device : " + self.name)

	def power_on(self):
		#debug('gsm on')
		self.timer_mode = 1
		self.enabled = 1
		self.enable_str = "on"
		if (self.timer_running == 0):
			self.timer_running = 1
			self.timer_add(0.1, _power_on_first, self)

	def power_off(self):
		#debug('gsm off')
		self.timer_mode = 0
		self.enabled = 0
		self.enable_str = "off"
		if (self.timer_running == 0):
			os.system("echo 0 > " + self.pows)

	def onclick(self):
		#debug('onclick')
		if (self.enabled):
			self.power_off()
		else:
			self.power_on()
		self.update_label()

	def init_label(self):
		#debug('init_label')
		self.get_status()
		self.update_label()

	def get_status(self):
		#debug('get_status')
		list=os.popen("cat " + self.pows)
		line = list.readline()
		if line.find('0') > -1:
			list.close()
			self.enabled = 0
			self.enable_str = "off"
		else:
			list.close()
			self.enabled = 1
			self.enable_str = "on"

	def update_label(self):
		#debug('update_label')
		self.button[1] = self.label_text(self.button[0], self.enable_str)
