#!/usr/bin/python

#
# Copyright (C) 2008 by OpenMoko, Inc.
# Written by Marek Lindner <marek@openmoko.com>
# All Rights Reserved
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#

import dbus


def debug(msg):
	print msg

class profile:
	def __init__(self, name="Profile"):
		self.name = name
		self.status = -1
		self.status_str = "unknown"
		self.dbus = dbus.SessionBus()
		self.dbus_name = "org.openmoko.qtopia.Phonestatus"
		self.dbus_path = "/Profiles"
		self.dbus_iface = "org.openmoko.qtopia.Profiles"
		self.runnable = 1
		try:
			self.qtopia_obj = self.dbus.get_object(self.dbus_name, self.dbus_path)
		except:
			self.runnable = 0
		else:
			try:
				self.qtopia_iface = dbus.Interface(self.qtopia_obj, dbus_interface=self.dbus_iface)
			except:
				self.runnable = 0
			else:
				self.profile_array = self.qtopia_iface.profiles()
		#debug("enter init device : " + self.name)

	def onclick(self):
		#debug('onclick')
		if (self.runnable):
			if (self.status == 7):
				self.status = 1
			else:
				self.status += 1
			self.set_status()
			self.update_label()

	def init_label(self):
		#debug('init_label')
		if self.runnable:
			self.get_status()
		self.update_label()

	def get_status(self):
		#debug('get_status')
		## call async as long as we can't fix the gobject mainloop
		self.status = self.qtopia_iface.currentProfile()[1]

	def set_status(self):
		#debug('set_status: ' + str(self.status))
		## call async as long as we can't fix the gobject mainloop
		self.qtopia_iface.setCurrentProfile(self.profile_array[self.status - 1])
		print self.qtopia_iface.currentProfile()

	def update_label(self):
		#debug('update_label: ' + str(self.status))
		if self.runnable:
			self.status_str = self.profile_array[self.status - 1][0]
			#debug('update_label: ' + self.status_str)
		self.button[1] = self.label_text(self.button[0], self.status_str)
