#!/usr/bin/python

#
# Copyright (C) 2008 by OpenMoko, Inc.
# Written by Marek Lindner <marek@openmoko.com>
# All Rights Reserved
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#

import dbus


def debug(msg):
	print msg

class suspend:
	def __init__(self, name="Suspend"):
		self.name = name
		self.status = -1
		self.status_str = "unknown"
		self.dbus = dbus.SessionBus()
		self.dbus_name = "org.enlightenment.wm.service"
		self.dbus_path = "/org/enlightenment/wm/RemoteObject"
		self.dbus_iface = "org.enlightenment.wm.IllumeConfiguration"
		self.runnable = 1
		try:
			self.e_obj = self.dbus.get_object(self.dbus_name, self.dbus_path)
		except:
			self.runnable = 0
		else:
			try:
				self.illume_iface = dbus.Interface(self.e_obj, dbus_interface=self.dbus_iface)
			except:
				self.runnable = 0
		#debug("enter init device : " + self.name)

	def dbus_get_value(self, value):
		#debug("value: " + str(value))
		self.status = value
		self.update_label()

	def dbus_error_handler(self, error):
		print "error getting bus names - %s" % str(error)
		self.status = -1
		self.status_str = "unknown"
		self.runnable = 0
		self.update_label()

	def onclick(self):
		#debug('onclick')
		if (self.runnable):
			if (self.status == 0):
				self.set_status(10)
			elif (self.status == 10):
				self.set_status(30)
			elif (self.status == 30):
				self.set_status(60)
			elif (self.status == 60):
				self.set_status(0)
			self.update_label()

	def init_label(self):
		#debug('init_label')
		if self.runnable:
			self.get_status()
		else:
			self.update_label()

	def get_status(self):
		#debug('get_status')
		# self.illume_iface.AutosuspendTiemoutGet(reply_handler=self.dbus_get_value, error_handler=self.dbus_error_handler)
		## call async as long as we can't fix the gobject mainloop
		value = self.illume_iface.AutosuspendTimeoutGet()
		self.dbus_get_value(value)

	def set_status(self, value):
		#debug('set_status: ' + str(value))
		# self.illume_iface.AutosuspendTimeoutSet(reply_handler=self.dbus_set_value, error_handler=self.dbus_error_handler)
		## call async as long as we can't fix the gobject mainloop
		self.illume_iface.AutosuspendTimeoutSet(int(value))
		self.status = value

	def update_label(self):
		#debug('update_label: ' + str(self.status))
		if self.runnable:
			if (self.status == 0):
				self.status_str = "off"
			elif (self.status == 10) or (self.status == 30) or (self.status == 60):
				self.status_str = str(self.status) + " sec"
			else:
				self.set_status(60)
				self.status_str = str(self.status) + " sec"
		self.button[1] = self.label_text(self.button[0], self.status_str)
