#!/usr/bin/python

#
# Copyright (C) 2008 by OpenMoko, Inc.
# Written by Marek Lindner <marek@openmoko.com>
# All Rights Reserved
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#

import os


def debug(msg):
	print msg

class sysinfo:
	def __init__(self, etk_obj, name="System Info"):
		self.name = name

		## gui ##
		self.etk_obj = etk_obj
		self.VBox = self.etk_obj.VBox()
		self.item_list = self.etk_obj.ListModel()
		self.lst = self.etk_obj.List(self.item_list, selectable=True,row_height=40, columns=[(480, self.etk_obj.KineticTextRenderer(slot=1),True)])
		self.VBox.append(self.lst, self.etk_obj.VBox.START, self.etk_obj.VBox.EXPAND_FILL, 0)

		self.data_file = "/etc/om-version"
		self.runnable = 1
		if not (os.path.isfile(self.data_file)):
			self.runnable = 0
		#debug("enter init device : " + self.name)

	def init_label(self):
		#debug('init_label')
		for index, item in enumerate(["Tag Name", "Version", "Branch", "Build Host", "Time Stamp"]):
			self.item_list.append([item, "<font_size=28>" + item])
			self.item_list.append([item + " data", "  unknown"])

		self.update_label()

	def onclick(self):
		#debug('onclick')
		self.get_om_version()
		self.edj_object.signal_emit("sysinfo-slide-in", "exposure")
		self.edj_object.part_text_set("settings-text", "Settings / System Information")

	def update_label(self):
		#debug('update_label')
		self.button[1] = self.label_text(self.button[0], "")

	def get_om_version(self):
		#debug('get_om_version')
		if self.runnable:
			file = open(self.data_file)
			version_info = file.readlines()
			self.lst.freeze()
			for index, line in enumerate(version_info):
				self.item_list[(index * 2) + 1][1] = "<font_size=16>  " + line.partition(':')[2].strip()
				if (index == 4):
					break
			self.lst.thaw()
			file.close()
